//Win C

#include<windows.h>
#include<string.h>

#include"table_window.h"
#include"control_window.h"

TableWindow *tableWindow;
ControlWindow *controlWindow;

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK CtlProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE instance, HINSTANCE prevInstance, 
		   PSTR cmdLine, int cmdShow) {
    static char *appName = "kanchoku";

    //window̃X^Co^
    WNDCLASSEX wndclass;
    wndclass.cbSize = sizeof(wndclass);
    wndclass.style = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc = WndProc;
    wndclass.cbClsExtra = 0;
    wndclass.cbWndExtra = 0;
    wndclass.hInstance =  instance;
    wndclass.hIcon = LoadIcon(instance, "kanchoku");
    wndclass.hIcon = NULL;
    wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground = CreateSolidBrush(RGB(192, 192, 192));
    wndclass.lpszMenuName = NULL;
    wndclass.lpszClassName = appName;
    wndclass.hIconSm = LoadIcon(instance, "kanmini");
                                //ACR
                                //On OffŕύX悤ɂ\
    RegisterClassEx(&wndclass);

    //C̃EBhENX
    tableWindow = new TableWindow(instance);

    //_CAO{bNXNX
    controlWindow = new ControlWindow(tableWindow);

    //window
    HWND hwnd;
    hwnd = CreateWindowEx(
			  WS_EX_TOPMOST | WS_EX_TOOLWINDOW,
			  appName,
			  "Win",
			  WS_DLGFRAME | WS_SYSMENU,
			  CW_USEDEFAULT,
			  CW_USEDEFAULT,
			  176,
			  100,
			  NULL,
			  NULL,
			  instance,
			  NULL);
    
    //window\
    ShowWindow(hwnd, cmdShow);
    UpdateWindow(hwnd);

    //bZ[W[v
    MSG msg;
    while(GetMessage(&msg, NULL, 0,0)) {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }

    //I
    return msg.wParam;
}

//window procedure
//Ptable windowɏ񂷂
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    return tableWindow->wndProc(hwnd, msg, wParam, lParam);
}

//window procedure(_CAO)
//Pdialog windowɏ񂷂
BOOL CALLBACK CtlProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    return controlWindow->wndProc(hwnd, msg, wParam, lParam);
}
