#include"parser.h"

//[hЂƂǂ
ControlBlock *Parser::parse() {
    setNextToken();
    return parseControl(); //[hcontrol blockЂƂ琬
}

//control blockЂƂǂ
ControlBlock *Parser::parseControl() {
    checkToken(LBRACE); //ŏ'{'
    setNextToken();

    ControlBlock *node = new ControlBlock(); //control blockp
    for(int i = 0; i < KEY_NUMBER; i++) {
	switch(currentToken) {
	case LBRACE:  //'{'
	    //lXgcontrol blockǂ
	    node->block[i] = parseControl();
	    setNextToken();
	    break;
	case RBRACE:  //'}'
	    //'}'uN
	    node->block[i] = 0;
	    break;
	case COMMA:   //','
	    //','ĂuN
	    node->block[i] = 0;
	    break;
	case STRING:  //"()"
	    //ubN
	    node->block[i] = new StringBlock(buffer);
	    setNextToken();
	    break;
	case SPECIAL: //@()
	    //ubN
	    node->block[i] = new SpecialBlock(buffer[0]);
	    setNextToken();
	    break;
	case 0:    //rŃt@CIꍇ
	    //G[
	    parseError();
	    break;
	}

	if(i != (KEY_NUMBER - 1)) {
	    //controlubN̍Ō̂ЂƂłȂA
	    //ɂ̓R}ȂĂ͂ȂȂB
	    checkToken(COMMA);
	    setNextToken();
	}
    }

    checkToken(RBRACE); //ŏ'}'
    return node;
}

//݂̃g[N߂
void Parser::checkToken(int target) {
    if(currentToken != target) {
	parseError(); //G[
    }
}

//g[NЂƂǂcurrentTokenɃZbg
void Parser::setNextToken() {
    currentToken = getToken();
}

//g[Nǂ
int Parser::getToken() {
    char c;
    is->get(c);

    //<si>
#ifndef ORIG
    //  '#'  ';' ȍ~̓Rg (s܂œǂ݂Ƃ΂)
    if(c == '#' || c == ';'){
	do{
	    is->get(c);
	}while(c != 0 && c != '\n' && c != '\r');
    }
#endif
    //</si>

    //ꕶ̃g[NV[Y
    switch(c) {
    case '{':
	return LBRACE;

    case '}':
	return RBRACE;

    case ',':
	return COMMA;

    case '\n': //s(XLbvǍsԍ𑝂₷)
	lineNumber++;
    case ' ':  //Xy[X(XLbv)
    case '\t': //^u(XLbv)
    case '\r': //^M(XLbv)
    //<si>
#ifndef ORIG
    case '\f': // ^L (XLbv)
#endif
    //</si>
	return getToken();

    case 0:
	return NULL;
    }

    //ꕶ
    if(c == '@') {
	is->get(c);
	buffer[0] = c;
	return SPECIAL;
    }

    //̎_Ŏĉ͕݁BG[B
    if(c != '"') {
	parseError();
    }

    //'"'܂œǂݍŁAbufferɊi[
    //ĕ񒆂ɂ'"'͏oĂȂƂɂȂ
    //<si>
    // ==> ύXBu"v́u"\""vƕ\L邱ƂŎwł悤ɂB
    // Au"\n"vu"\tv͖ΉB
    // ܂Au\v́APɎ̈ꕶGXP[v邾B
    // u\v́u"\\"vƂȂ΂ȂȂȂ̂ŁAӁB
    // Shift-JIS  2 oCgڂɁu\v܂ޕAƑΏcc
    //</si>
    is->get(c);
    int count = 0;
    while(c != '"') {
	if(c == 0) {
	    exit(1); //łƃG[ɁB
	}
	//<si>
#ifdef ORIG
	buffer[count] = c;
	count++;
	is->get(c);
#else
	if(IS_SJIS1(c)){ // 擪 1 oCgĔf
	    // Shift-JIS  2 oCg
	    buffer[count] = c; count++; is->get(c);
	    buffer[count] = c; count++; is->get(c);
	}else{
	    // 2 oCgȂ
	    if(c == '\\'){
		// ŏ́u\v́APɓǂ݂Ƃ΂
		is->get(c);
	    }
	    buffer[count] = c; count++; is->get(c);
	}
#endif
	//</si>
    }
    buffer[count] = 0;

    return STRING;
}

//ǂ݂݂Ɏsꍇ
void Parser::parseError() {
    sprintf(buffer,
	    "e[ut@C %dsڂُł", lineNumber);
    MessageBoxEx(hwnd,
		 buffer,
		 "G[",
		 MB_OK | MB_ICONERROR, LANG_JAPANESE);
    exit(1);
}
